#### Red Hat Package Specification File (Requires RPM 3.0 or Higher)
#
# File: Zope-2.0.1.spec
#
# Digicool Z-Object Programming Environment (ZOPE)
#
#   "Zope is an Open Source application server and portal
#    toolkit used for building high-performance, dynamic Web sites."
#
# An independent 'BuildRoot:' directive is used so that that this package
# can be built in the /var/tmp directory, for the case where the existing
# software on the build host would be disrupted by installing-after-build-
# to-package onto that system.
#
# Sample Package Names:
#   Zope-2.0.1-1.i386.rpm
#
# Modification History:
# 09-Dec-98 jrr Original 1.9beta1 Release
# 29-Jan-99 jrr Updated to 1.9.0 Final Release
# 01-Mar-99 jrr Updated to 1.10.2
# 23-Jun-99 jrr Added /etc/rc.d/init.d/zope and reworked scripts
# 24-Jun-99 jrr Updated to 1.10.3
# 13-Jul-99 jrr Fixed some packaging bugs that crept in
# 21-Jul-99 jrr Added in accidently omitted SearchIndex/{Query,Splitter}.so
# 10-Sep-99 jrr Updated to 2.0.0
# 17-Sep-99 jrr Updated to 2.0.1
#
# RPM Mods:
# (-) Stripped all binaries
# (-) Relocated many .so extensions from common lib-dynlib into module-dirs
# (-) Unused Scheduler subsystem removed re Digicool
# (-) Obsolete ZopeHTTPServer removed re Digicool (replaced by ZServer)
# (-) Draft objects are no longer supported.
# (+) Replaced ZODB 2 with ZODB 3, a much advanced multithread OODB
# (+) XML support
# (+) Very fast Medusa-based multithreaded ZServer added
# (+) Z Classes, a new mechanism for building Zope applications
# (+) Read-only DOM interface on Zope objects added
# (+) Support for XML-RPC clients
# (+) WebDAV level 1 support
# (+) Added property sheets. Documentation is forthcoming.
# (+) Added zpasswd.py program for encrypting password in /var/zope/access.
# (!) Default ports used by ZServer changed to 8080/HTTP, 8021/FTP, 8099/MONITOR
#
# NOTE to Future ZOPE RPM Maintainers:
#
# The Zope tarball contains many subsystems, some dependent on Zope and
# some that can be used independently.  The independent ones have bee
# placed into the common /usr/lib/python1.5/site-packages/ directory tree
# while for the others, I've created a new directory:
#
#     /usr/lib/python1.5/site-packages/ZopeWorld/
#
# The contents of that directory is -not- a Python Package such that
# anyone must "import ZopeWorld".  Rather, there is a ZopeWorld.pth
# file in the site-packages directory that causes ZopeWorld to get
# added to the Python PATH variable, and therefore its contents are
# found via normal path searches.  This does mean naming collisions
# are possible with non-Zope packages, but until Zope is reorganized
# into a true Python Package layout, this cannot be helped.
#
####

####
# Section: Preamble (Items Displayed When Users Request Info About Package)
#
# The order of the entries below is unimportant.
#
####

Name:               Zope
Version:            2.0.1
Release:            2
Copyright:          Zope Public License (ZPL)
Vendor:             Digital Creations, L.C.
URL:                http://www.zope.org/
Packager:           Jeff Rush <jrush@taupro.com>
BuildRoot:          /var/tmp/Zope-%{version}-rootdir

Source0: http://www.zope.org/Download/Releases/Zope-%{version}/Zope-%{version}-src.tgz
Source1: http://www.zope.org/Documentation/Guides/ZCMG/ZCMG.html.tgz
Source2: http://www.zope.org/Documentation/Guides/DTML/DTML.html.tgz
Source3: http://www.zope.org/Documentation/Guides/ZSQL/ZSQL.html.tgz
Source4: http://www.zope.org/Documentation/Guides/Zope-ProductTutorial.tar.gz
Source5: Zope-%{version}-zope
Source6: Zope-%{version}-Zope.cgi
Source7: Zope-%{version}-README.RPM
Source8: Zope-%{version}-zserver-wo-pcgi.sh
Source9: Zope-%{version}-zserver-w-pcgi.sh

Patch0: Zope-%{version}-pcgi.patch
Patch1: Zope-%{version}-pypath.patch

#----------------------------------------------------------------------
Summary:            An application server and portal toolkit for building Web sites.
Group:              Development/Tools
Requires:           python >= 1.5.2

%description
The Z Object Programming Environment (Zope) is a Python-based,
'through-the-web' development framework for building
high-performance, dynamic web sites, using a powerful and simple
scripting object model and high-performance, integrated object database.

For a fully functional installation of Zope, install this single huge
package and then _either_ the Zope-zserver RPM, for a minimal Python-based
web server; or the Zope-pcgi RPM, for use with Apache's CGI facility.

If you only want portions of Zope, there are subpackages available
for each subsystem and you should _not_ install RPM.

#----------------------------------------------------------------------
%package core
Summary:            Central Core of Zope w/General Extensions
Group:              Development/Tools
Requires:           python >= 1.5.2, Zope-components, Zope-ztemplates, Zope-zpublisher, Zope-services

%description core
The Z Object Programming Environment (Zope) is a Python-based,
'through-the-web' development framework for building
high-performance, dynamic web sites, using a powerful and simple
scripting object model and high-performance, integrated object database.
The Zope-core package contains the central core programs and general
extensions needed to run Zope.

For a fully functional installation of Zope, install Zope, Zope-components,
Zope-core, Zope-services, Zope-zpublisher, and Zope-ztemplates, and one of
the following packages: Zope-zserver, for a minimal Python-based Web
server; or Zope-pcgi, for using Zope with Apache's CGI facility.

#----------------------------------------------------------------------
%package components
Summary:            A group of standalone Python binary extension modules.
Group:              Development/Libraries
Requires:           python >= 1.5.2

%description components
The Zope-components package includes a group of standalone Python extension
modules, including BTree, cPickle/cStringIO, ExtensionClass, Acquisition,
MethodObject, MultiMapping, ThreadLock, Missing, Sync, Record,
ComputedAttribute and zlib.  These modules can be used with the Zope
application server and portal toolkit.

#----------------------------------------------------------------------
%package ztemplates
Summary:            A template for creating dynamic HTML for Zope.
Group:              Development/Libraries
Requires:           python >= 1.5.2

%description ztemplates
The Zope-ztemplates package contains a Python-based template mechanism for
creating dynamic HTML sources, with Python expressions, looping constructs,
etc. The Z Template system can be used with the Zope application server and
portal tookit, or it can be used standalone. Z Template was called
DocumentTemplate in the olden days (before Zope).

#----------------------------------------------------------------------
%package zpublisher
Summary:            An object publishing mechanism for Zope.
Group:              Development/Libraries
Requires:           python >= 1.5.2, Zope-components >= 2.0

%description zpublisher

Zpublisher is a Python-based object publishing mechanism that maps URLs
to an object hierarchy and handles the interface between the Web server
and the Web application, hiding many complex details.  Zpublisher is
used with the Zope application server and portal toolkit, but it can be
used standalone as well.  Zpublisher was called Bobo before Zope came along.


#----------------------------------------------------------------------
%package services
Summary:            Middle-level services for Zope.
Group:              Development/Libraries
Requires:           python >= 1.5.2, Zope-components >= 2.0

%description services
The Zope-services package contains a group of middle-level services needed
by the Zope application server and portal toolkit (but not specifically
tied to Zope). Services included are DateTime, SearchIndex and
StructuredText.


#----------------------------------------------------------------------
%package zserver
Summary:            Initial Object Database/Standalone HTTP Server
Group:              Development/Tools
Requires:           Zope
Conflicts:          Zope-pcgi

%description zserver
The Zope-zserver package contains the files needed for setting up a
Zope website, including an empty object database. Zope is an application
server and portal toolkit.

Also included is the ZServer, which is a small, standalone web server
written in Python.  The ZServer uses the very fast Medusa technology
and is multithreaded.  This package comes preconfigured to serve
web pages on port 8080 and ftp access on 8021.  The programmer's port
interface comes disabled for security reasons but can be reenabled.

If you wish to instead run Zope thru Apache, do not use this package
but rather the Zope-pcgi package.  This package is for -standalone-
web serving.

#----------------------------------------------------------------------
%package pcgi
Summary:            Persistent CGI (PCGI) capabilities for Zope.
Group:              Applications/Internet
Requires:           Zope, apache >= 1.3
Conflicts:          Zope-zserver
URL:                http://starship.python.net/crew/jbauer/persistcgi/

%description pcgi
Persistent CGI (PCGI) is an architecture designed by Digital Creations
(http://www.digicool.com) for publishing Web objects as long-running
server processes in order to improve the performance of serving Web
pages.  This package is PCGI for use with the Zope application server
and portal toolkit.

It is not necessary for ZServer to actually listen for incoming HTTP
requests.  If you want Apache to do the actual listening and serving,
then you can use ZServer's PCGI component to communicate with Apache.

Please note that versions of the Apache Web server prior to 1.3 do not
have a sufficiently implemented rewrite module to provide authentication
for Zope.  You'll need to upgrade your Apache if you're using a version
prior to 1.3.

For PCGI HOWTO information, see:
    http://starship.python.net/crew/jbauer/persistcgi/

########## 
#
# The following environment variables are automatically defined for use
# in any of the following shell scripts:
#
#   RPM_SOURCE_DIR      { where sources originally reside }
#   RPM_BUILD_DIR       { where sources get unpacked into }
#   RPM_DOC_DIR
#   RPM_OPT_FLAGS
#   RPM_ARCH
#   RPM_OS
#   RPM_ROOT_DIR
#   RPM_BUILD_ROOT      { where final images get placed before packaging }
#   RPM_PACKAGE_NAME
#   RPM_PACKAGE_VERSION
#   RPM_PACKAGE_RELEASE
#
##########

####
# Section: Prep Script (Prepare to Build; Usually Just Unpacking the Sources)
####
%prep
# Create Build Subdirectory and Unpack the Main Tar Ball
%setup -q -n %{name}-%{version}-src
%patch0 -p1

%setup -q -T -D -c -a 1 -n %{name}-%{version}-src/ZopeContentManagersGuide
%setup -q -T -D -c -a 2 -n %{name}-%{version}-src/GuideToDTML
%setup -q -T -D -c -a 3 -n %{name}-%{version}-src/GuideToZSQL
%setup -q -T -D    -a 4 -n %{name}-%{version}-src

# Reset RPM's Concept of "-n" Back to the Top-Level Package Dir Name
%setup -q -T -D -n %{name}-%{version}-src

%patch1 -p1

# Create a Temporary Holding Area in the RPM's Source Directory for Docs
mkdir misc

# Some of the docs incorrectly have the 'Execute' bit set on their files
# so we do this for security reasons (and we can't use chmod -R if we
# want to only change files modes and not those of subdirectories) ;-(
find ZopeContentManagersGuide -type f -exec chmod 644 \{\} \;
find GuideToDTML              -type f -exec chmod 644 \{\} \;
find GuideToZSQL              -type f -exec chmod 644 \{\} \;
find Tutorial                 -type f -exec chmod 644 \{\} \;

####
# Section: Build Script (Actually Perform the Build; Usually Just 'make')
####
%build
  cp %{SOURCE7} $RPM_BUILD_DIR/%{name}-%{version}-src/README.RPM

  echo Building the PCGI Wrapper...
  (cd pcgi
  ./configure --prefix=/usr
  make)

  echo Building Extension Modules...

  # Set up an easily-accessible Makefile template
  cp lib/python/Shared/DC/xml/pyexpat/Makefile.pre.in  Makefile.pre.in

  cp Makefile.pre.in lib/Components/BTree
  cp Makefile.pre.in lib/Components/ExtensionClass
  cp Makefile.pre.in lib/Components/cPickle
  cp Makefile.pre.in lib/Components/zlib

  cp Makefile.pre.in lib/python/DocumentTemplate
  cp Makefile.pre.in lib/python/SearchIndex
  cp Makefile.pre.in lib/python/ZODB

  # === General Loadable-Binary-Library Python Components ===

  # BTree.so IIBTree.so IOBTree.so OIBTree.so intSet.so
  (cd lib/Components/BTree
   make -f Makefile.pre.in boot PYTHON=/usr/bin/python
   make CFLAGS="-I../../python/ZODB/ -I/usr/include/python1.5/"
   make clean
  )

  # ExtensionClass.so Acquisition.so MethodObject.so MultiMapping.so
  # ThreadLock.so Missing.so Sync.so Record.so ComputedAttribute.so
  (cd lib/Components/ExtensionClass
   make -f Makefile.pre.in boot PYTHON=/usr/bin/python
   make
   make clean
   mkdir ExtensionClass
   mv test_*.py release.* ExtensionClass
   mv COPYRIGHT.txt ExtensionClass.COPYRIGHT.txt
   mv README ExtensionClass.README
  )

  # cStringIO.so cPickle.so
  (cd lib/Components/cPickle
   make -f Makefile.pre.in boot PYTHON=/usr/bin/python
   make
   make clean
  )

  # zlib.so
  (cd lib/Components/zlib
   make -f Makefile.pre.in boot PYTHON=/usr/bin/python
   make
   make clean
  )

  # pyexpat.so
  (cd lib/python/Shared/DC/xml/pyexpat
   make -f Makefile.pre.in boot PYTHON=/usr/bin/python
   make
   make clean
   rm -rf expat
   mv README   $RPM_BUILD_DIR/%{name}-%{version}-src/misc/pyexpat.README
   find . -type f -not -name '*.py' -not -name '*.so' -exec rm \{\} \;
  )

  # === Zope Subsystems ===

  # cDocumentTemplate.so
  (cd lib/python/DocumentTemplate
   make -f Makefile.pre.in boot PYTHON=/usr/bin/python
   make
   make clean
   find . -type f -not -name '*.py' -not -name '*.so' -not -name '*.stx' -exec rm \{\} \;
  )

   # TimeStamp.so cPersistence.so cPickleCache.so winlock.so
  (cd lib/python/ZODB
   make -f Makefile.pre.in boot PYTHON=/usr/bin/python
   make
   make clean
   find . -type f -not -name '*.py' -not -name '*.so' -not -name '*.gif' -not -name '*.html' -not -name '*.stx' -exec rm \{\} \;
  )

  # Splitter.so Query.so
  (cd lib/python/SearchIndex
   make -f Makefile.pre.in boot PYTHON=/usr/bin/python
   make
   make clean
   find . -type f -not -name '*.py' -not -name '*.so' -exec rm \{\} \;
  )

  # Remove Non-Release Items Before Copying Dirs
  # into Package, to Minimize Package Size

  find lib/python -type f -and \( -name 'Setup' -or -name '.cvsignore' \) -exec rm \{\} \;
  rm ZServer/medusa/monitor_client_win32.py

####
# Section: Install-After-Build Script (Often Just 'make install')
####
%install
  rm -rf $RPM_BUILD_ROOT

  # Make the Necessary Directories
  install -m0755 --directory      $RPM_BUILD_ROOT/usr/lib/python1.5/site-packages
  install -m0755 --directory      $RPM_BUILD_ROOT/usr/lib/python1.5/site-packages/ZopeWorld
  install -m0755 --directory      $RPM_BUILD_ROOT/usr/lib/python1.5/site-packages/ZopeWorld/Zope
  install -m0755 --directory      $RPM_BUILD_ROOT/usr/lib/python1.5/lib-dynload
  install -m0755 --directory      $RPM_BUILD_ROOT/usr/bin
  install -m0755 --directory      $RPM_BUILD_ROOT/etc/rc.d/init.d
  install -m0775 --directory      $RPM_BUILD_ROOT/var/zope
  install -m0711 --directory      $RPM_BUILD_ROOT/var/zope/var
  install -m0775 --directory      $RPM_BUILD_ROOT/var/zope/Products
  install -m0775 --directory      $RPM_BUILD_ROOT/var/log

  (cd lib/Components
   install -m0644 ExtensionClass/*.py  $RPM_BUILD_ROOT/usr/lib/python1.5/
   install -s     BTree/*.so           $RPM_BUILD_ROOT/usr/lib/python1.5/lib-dynload
   install -s     ExtensionClass/*.so  $RPM_BUILD_ROOT/usr/lib/python1.5/lib-dynload
   install -s     cPickle/*.so         $RPM_BUILD_ROOT/usr/lib/python1.5/lib-dynload
   install -s     zlib/zlib.so         $RPM_BUILD_ROOT/usr/lib/python1.5/lib-dynload
  )

  cp -a ZServer/                       $RPM_BUILD_ROOT/usr/lib/python1.5/site-packages/
  cp -a utilities/                     $RPM_BUILD_ROOT/usr/lib/python1.5/site-packages/ZopeWorld/
  cp    zpasswd.py                     $RPM_BUILD_ROOT/usr/lib/python1.5/site-packages/ZopeWorld/

  (cd lib/python
   # These are generally useful modules, (relatively) independent of Zope
   cp -a DocumentTemplate/             $RPM_BUILD_ROOT/usr/lib/python1.5/site-packages/
   cp -a SearchIndex/                  $RPM_BUILD_ROOT/usr/lib/python1.5/site-packages/
   cp -a ZPublisher/                   $RPM_BUILD_ROOT/usr/lib/python1.5/site-packages/
   cp -a DateTime/                     $RPM_BUILD_ROOT/usr/lib/python1.5/site-packages/
   cp -a StructuredText/               $RPM_BUILD_ROOT/usr/lib/python1.5/site-packages/

   # These are integral parts of Zope and can't really stand alone
   cp    version.txt                   $RPM_BUILD_ROOT/usr/lib/python1.5/site-packages/ZopeWorld/
   cp -a Zope/                         $RPM_BUILD_ROOT/usr/lib/python1.5/site-packages/ZopeWorld/
   cp -a AccessControl/                $RPM_BUILD_ROOT/usr/lib/python1.5/site-packages/ZopeWorld/
   cp -a App/                          $RPM_BUILD_ROOT/usr/lib/python1.5/site-packages/ZopeWorld/
   cp -a HelpSys/                      $RPM_BUILD_ROOT/usr/lib/python1.5/site-packages/ZopeWorld/
   cp -a OFS/                          $RPM_BUILD_ROOT/usr/lib/python1.5/site-packages/ZopeWorld/
   cp -a TreeDisplay/                  $RPM_BUILD_ROOT/usr/lib/python1.5/site-packages/ZopeWorld/
   cp -a ZClasses/                     $RPM_BUILD_ROOT/usr/lib/python1.5/site-packages/ZopeWorld/
   cp -a Shared/                       $RPM_BUILD_ROOT/usr/lib/python1.5/site-packages/ZopeWorld/
   cp -a Products/                     $RPM_BUILD_ROOT/usr/lib/python1.5/site-packages/ZopeWorld/
   cp -a ZODB/                         $RPM_BUILD_ROOT/usr/lib/python1.5/site-packages/ZopeWorld/
   cp -a webdav/                       $RPM_BUILD_ROOT/usr/lib/python1.5/site-packages/ZopeWorld/
   install -m0644 *.py                 $RPM_BUILD_ROOT/usr/lib/python1.5/site-packages/ZopeWorld/
  )

  # Give ZODB the -particular- version of cPickle that ships with Zope
  install -s lib/Components/cPickle/cPickle.so $RPM_BUILD_ROOT/usr/lib/python1.5/site-packages/ZopeWorld/ZODB/

  # Make a ZopeWorld.pth file to redirect Python imports
  # into the ZopeWorld site-packages subdirectory.
  cat <<-EOF >$RPM_BUILD_ROOT/usr/lib/python1.5/site-packages/ZopeWorld.pth
ZopeWorld
EOF
  chmod 644 $RPM_BUILD_ROOT/usr/lib/python1.5/site-packages/ZopeWorld.pth

  install -m 0755 -s pcgi/pcgi-wrapper  $RPM_BUILD_ROOT/usr/bin/pcgi-wrapper
  install pcgi/pcgi_publisher.py        $RPM_BUILD_ROOT/usr/lib/python1.5/pcgi_publisher.py
  install pcgi/Util/killpcgi.py         $RPM_BUILD_ROOT/usr/lib/python1.5/killpcgi.py

  # Establish an Empty Zope Object Database
  install -m 0664 var/Data.fs.in        $RPM_BUILD_ROOT/var/zope/var/Data.fs

  # Create a Safe Preowned Zope Logfile, for ZServer
  # (Otherwise a symlink-redirect attack is possible!)
  touch $RPM_BUILD_ROOT/var/log/zope
  touch $RPM_BUILD_ROOT/var/log/zope.fatal

  # Declare the Superuser of the Default Zope Project
   cat <<-EOF                         >$RPM_BUILD_ROOT/var/zope/access
	superuser:123:localhost
EOF
# (Do Not DETAB! See man bash re 'here' documents and dash before EOF)

  install -m 0755 %{SOURCE5} $RPM_BUILD_ROOT/etc/rc.d/init.d/zope
  install -m 0755 %{SOURCE6} $RPM_BUILD_ROOT/var/zope/Zope.cgi
  install -m 0755 %{SOURCE8} $RPM_BUILD_ROOT/var/zope/zserver_wo_pcgi.sh
  install -m 0755 %{SOURCE9} $RPM_BUILD_ROOT/var/zope/zserver_w_pcgi.sh
  install -m 0755 z2.py      $RPM_BUILD_ROOT/var/zope/z2.py

  # Precompile Python Source for Faster Imports During Usage
  # (Since user of package may not have write-access to install directory)
  python -O /usr/lib/python1.5/compileall.py    -d /usr/lib/python1.5/  $RPM_BUILD_ROOT/usr/lib/python1.5
  python    /usr/lib/python1.5/compileall.py    -d /usr/lib/python1.5/  $RPM_BUILD_ROOT/usr/lib/python1.5

  # Remove Duplicate Documentation Embedded in Python Package Dirs
  (cd $RPM_BUILD_ROOT/usr/lib/python1.5/site-packages
   rm     ZopeWorld/AccessControl/AccessControl.txt
   rm     ZopeWorld/Products/ZCatalog/ZCatalog.txt
   rm     ZServer/{INSTALL,README}.txt
   rm     DateTime/DateTime.html
   rm     DocumentTemplate/Let.stx
   rm -rf StructuredText/regressions/
  )

####
# Section: Delivery Install/Uninstall Scripts (Pre/Post Install/Erase Scripts)
####

%preun zserver
  if [ "$1" = 0 ] ; then
    if [ /var/zope/zserver_wo_pcgi.sh -ef /var/zope/zserver.sh ]; then
      rm /var/zope/zserver.sh
    fi
    /sbin/chkconfig --del zope
  fi

%preun pcgi
  if [ "$1" = 0 ] ; then
    if [ /var/zope/zserver_w_pcgi.sh -ef /var/zope/zserver.sh ]; then
      rm /var/zope/zserver.sh
    fi
    /sbin/chkconfig --del zope
  fi

%post zserver
  /sbin/chkconfig --add zope
  ln -sf /var/zope/zserver_wo_pcgi.sh /var/zope/zserver.sh

%post pcgi
  /sbin/chkconfig --add zope
  ln -sf /var/zope/zserver_w_pcgi.sh /var/zope/zserver.sh

####
# Section: Verify Script (Check for Proper Installation of Package)
####

%verifyscript zserver
  if [ ! /var/zope/zserver_wo_pcgi.sh -ef /var/zope/zserver.sh ]; then
    echo "/var/zope/zserver_wo_pcgi.sh should be linked to /var/zope/zserver.sh" >&2
  fi

%verifyscript pcgi
  if [ ! /var/zope/zserver_w_pcgi.sh -ef /var/zope/zserver.sh ]; then
    echo "/var/zope/zserver_w_pcgi.sh should be linked to /var/zope/zserver.sh" >&2
  fi

####
# Section: Clean Script (Tidy Up Build Area After a Build Completes)
####
%clean
  rm -rf $RPM_BUILD_ROOT

####
# Section: Files (List of Files w/Attributes Making Up Package)
####

# Note: the root package of just Zope (w/o any -<stuff>) includes all
#       of the Zope release, for those who want to quickly install
#       everything.  The release is also packaged as separate subpackages
#       for those who want to be more selective.

%files
  %defattr(-, root, root)

  #-- Copy of Zope-core Contents:
  %doc LICENSE.txt README.txt README.RPM

  # User's Guides
  %doc $RPM_BUILD_DIR/$RPM_PACKAGE_NAME-$RPM_PACKAGE_VERSION-src/ZopeContentManagersGuide
  %doc $RPM_BUILD_DIR/$RPM_PACKAGE_NAME-$RPM_PACKAGE_VERSION-src/GuideToZSQL
  %doc $RPM_BUILD_DIR/$RPM_PACKAGE_NAME-$RPM_PACKAGE_VERSION-src/Tutorial
  %doc doc/
  %doc lib/python/AccessControl/AccessControl.txt
  %doc lib/python/Products/ZCatalog/ZCatalog.txt
  %doc misc/pyexpat.README

  # ZOPE-Specific Python Packages
  /usr/lib/python1.5/site-packages/ZopeWorld/
  /usr/lib/python1.5/site-packages/ZopeWorld.pth

  #-- Copy of Zope-components Contents:
  %doc lib/Components/ExtensionClass/ExtensionClass/
  %doc lib/Components/ExtensionClass/*.stx
  %doc lib/Components/cPickle/cPickle.stx
  %doc lib/Components/ExtensionClass/ExtensionClass.README
  %doc lib/Components/ExtensionClass/ExtensionClass.COPYRIGHT.txt

  # BTree Module(s):
  /usr/lib/python1.5/lib-dynload/BTree.so
  /usr/lib/python1.5/lib-dynload/IIBTree.so
  /usr/lib/python1.5/lib-dynload/IOBTree.so
  /usr/lib/python1.5/lib-dynload/OIBTree.so
  /usr/lib/python1.5/lib-dynload/intSet.so

  # ExtensionClass Module(s):
  /usr/lib/python1.5/lib-dynload/Acquisition.so
  /usr/lib/python1.5/lib-dynload/ComputedAttribute.so
  /usr/lib/python1.5/lib-dynload/ExtensionClass.so
  /usr/lib/python1.5/lib-dynload/MethodObject.so
  /usr/lib/python1.5/lib-dynload/Missing.so
  /usr/lib/python1.5/lib-dynload/MultiMapping.so
  /usr/lib/python1.5/lib-dynload/Record.so
  /usr/lib/python1.5/lib-dynload/Sync.so
  /usr/lib/python1.5/lib-dynload/ThreadLock.so
  /usr/lib/python1.5/ComputedAttribute.py
  /usr/lib/python1.5/Xaq.py

  # zlib Module(s):
  #  /usr/lib/python1.5/lib-dynload/zlib.so

  # cPickle Module(s):
  # We omit cPickle from the package, because it ships with the Python
  # RPM itself, in the Red Hat 5.1/5.2 distribution.  If we did include
  # it, it would conflict.  What to do?
  # %doc lib/Components/cPickle/cPickle.stx
  # /usr/lib/python1.5/lib-dynload/cStringIO.so
  # /usr/lib/python1.5/lib-dynload/cPickle.so

  #-- Copy of Zope-zpublisher Contents:
  /usr/lib/python1.5/site-packages/ZPublisher/

  #-- Copy of Zope-ztemplates Contents:
  %doc lib/python/DocumentTemplate/Let.stx
  %doc $RPM_BUILD_DIR/$RPM_PACKAGE_NAME-$RPM_PACKAGE_VERSION-src/GuideToDTML/
  /usr/lib/python1.5/site-packages/DocumentTemplate/

  #-- Copy of Zope-services Contents:
  %doc lib/python/DateTime/DateTime.html
  %doc lib/python/StructuredText/regressions/
  /usr/lib/python1.5/site-packages/DateTime/
  /usr/lib/python1.5/site-packages/StructuredText/
  /usr/lib/python1.5/site-packages/SearchIndex/

%files core
  %defattr(-, root, root)
  %doc LICENSE.txt README.txt README.RPM

  # User's Guides
  %doc $RPM_BUILD_DIR/$RPM_PACKAGE_NAME-$RPM_PACKAGE_VERSION-src/ZopeContentManagersGuide
  %doc $RPM_BUILD_DIR/$RPM_PACKAGE_NAME-$RPM_PACKAGE_VERSION-src/GuideToZSQL
  %doc $RPM_BUILD_DIR/$RPM_PACKAGE_NAME-$RPM_PACKAGE_VERSION-src/Tutorial
  %doc doc/
  %doc lib/python/AccessControl/AccessControl.txt
  %doc lib/python/Products/ZCatalog/ZCatalog.txt
  %doc misc/pyexpat.README

  # ZOPE-Specific Python Packages
  /usr/lib/python1.5/site-packages/ZopeWorld/
  /usr/lib/python1.5/site-packages/ZopeWorld.pth

%files components
  %defattr(-, root, root)
  %doc LICENSE.txt
  %doc lib/Components/ExtensionClass/ExtensionClass/
  %doc lib/Components/ExtensionClass/*.stx
  %doc lib/Components/cPickle/cPickle.stx
  %doc lib/Components/ExtensionClass/ExtensionClass.README
  %doc lib/Components/ExtensionClass/ExtensionClass.COPYRIGHT.txt

  # BTree Module(s):
  /usr/lib/python1.5/lib-dynload/BTree.so
  /usr/lib/python1.5/lib-dynload/IIBTree.so
  /usr/lib/python1.5/lib-dynload/IOBTree.so
  /usr/lib/python1.5/lib-dynload/OIBTree.so
  /usr/lib/python1.5/lib-dynload/intSet.so

  # ExtensionClass Module(s):
  /usr/lib/python1.5/lib-dynload/Acquisition.so
  /usr/lib/python1.5/lib-dynload/ComputedAttribute.so
  /usr/lib/python1.5/lib-dynload/ExtensionClass.so
  /usr/lib/python1.5/lib-dynload/MethodObject.so
  /usr/lib/python1.5/lib-dynload/Missing.so
  /usr/lib/python1.5/lib-dynload/MultiMapping.so
  /usr/lib/python1.5/lib-dynload/Record.so
  /usr/lib/python1.5/lib-dynload/Sync.so
  /usr/lib/python1.5/lib-dynload/ThreadLock.so
  /usr/lib/python1.5/ComputedAttribute.py
  /usr/lib/python1.5/Xaq.py

  # zlib Module(s):
  #  /usr/lib/python1.5/lib-dynload/zlib.so

  # cPickle Module(s):
  # We omit cPickle from the package, because it ships with the Python
  # RPM itself, in the Red Hat 5.1/5.2 distribution.  If we did include
  # it, it would conflict.  What to do?
  # %doc lib/Components/cPickle/cPickle.stx
  # /usr/lib/python1.5/lib-dynload/cStringIO.so
  # /usr/lib/python1.5/lib-dynload/cPickle.so

%files zpublisher
  %defattr(-, root, root)
  %doc LICENSE.txt
  /usr/lib/python1.5/site-packages/ZPublisher/

%files ztemplates
  %defattr(-, root, root)
  %doc LICENSE.txt  lib/python/DocumentTemplate/Let.stx
  %doc $RPM_BUILD_DIR/$RPM_PACKAGE_NAME-$RPM_PACKAGE_VERSION-src/GuideToDTML/
  /usr/lib/python1.5/site-packages/DocumentTemplate/

%files services
  %defattr(-, root, root)
  %doc LICENSE.txt  lib/python/DateTime/DateTime.html
  %doc lib/python/StructuredText/regressions/
  /usr/lib/python1.5/site-packages/DateTime/
  /usr/lib/python1.5/site-packages/StructuredText/
  /usr/lib/python1.5/site-packages/SearchIndex/

%files zserver
  %defattr(-, root, root)
  %doc LICENSE.txt  ZServer/INSTALL.txt  ZServer/README.txt
  /usr/lib/python1.5/site-packages/ZServer/

  %config                     /etc/rc.d/init.d/zope
  %config                     /var/zope/access
  %config                     /var/zope/z2.py
  %config                     /var/zope/zserver_wo_pcgi.sh

  %verify(not size md5 mtime) /var/log/zope
  %verify(not size md5 mtime) /var/log/zope.fatal

  # IMPORTANT: ZopeHTTPserver runs as user nobody and
  #            must have r/w access to the var/ directory
  #            so that it can create temp and index files.
  %defattr(-, nobody, root)
  %dir                        /var/zope/
  %dir                        /var/zope/Products
  %dir                        /var/zope/var/
  %verify(not size md5 mtime) /var/zope/var/Data.fs

%files pcgi
  %defattr(-, root, root)
  %doc LICENSE.txt  pcgi/README
  %doc pcgi/Example/  pcgi/Test/  pcgi/Util/

  /usr/bin/pcgi-wrapper
  /usr/lib/python1.5/pcgi_publisher.py
  /usr/lib/python1.5/killpcgi.py
  /usr/lib/python1.5/site-packages/ZServer/
  %config                     /etc/rc.d/init.d/zope
  %config                     /var/zope/access
  %config                     /var/zope/z2.py
  %config                     /var/zope/zserver_w_pcgi.sh
  %verify(not size md5 mtime) /var/log/zope
  %verify(not size md5 mtime) /var/log/zope.fatal
                              /var/zope/Zope.cgi

  # IMPORTANT: PCGI runs as user nobody and
  #            must have r/w access to the var/ directory
  #            so that it can create temp and index files.
  %defattr(-, nobody, root)
  %dir                        /var/zope/
  %dir                        /var/zope/Products
  %dir                        /var/zope/var/
  %verify(not size md5 mtime) /var/zope/var/Data.fs

%changelog
* Mon Sep 20 1999 Tim Powers <timp@redhat.com>
- got package from Jeff Rush's web site. 
- Rebuilt for Powertools.

* Thu Sep 9 1999 Tim Powers <timp@redhat.com>
- updated sources to 2.0.0
- _major_ spec file cleanups
- merged patch from src.rpm authored by Andreas Kostyrka <andreas@mtg.co.at>
- borrowed some things from Andreas Kostyrka's spec file

* Mon Aug 30 1999 Tim Powers <timp@redhat.com>
- changed groups

* Tue Aug 17 1999 Tim Powers <timp@redhat.com>
- chown permissions on some files in /var/local for the pcgi package

* Mon Aug 2 1999 Tim Powers <timp@redhat.com>
- changed buildroot to be in /var/tmp instead of /tmp
- rebuilt for 6.1

* Tue Jul 6 1999 Tim Powers <timp@redhat.com>
- started changelog
- cleaned up spec file
- built for powertools
